#include <pwd.h>
#include <stdio.h>
#include <errno.h>
#include <netdb.h>
#include <string.h>
#include <signal.h>
#include <stdlib.h>
#include <unistd.h>

#include <sys/time.h>
#include <sys/types.h>
#include <sys/socket.h>

#include <arpa/inet.h>

#include <netinet/in.h>

#include "lstat.h"

#define MAXLENGTH       70

char BUF[MAXLENGTH];

void output(int sock_des, char *password);
void input(int sock_des);

int main(int argc, char **argv)
{
    struct hostent *he;
    struct in_addr **addrptr;
    struct sockaddr_in sin;
    char *password, ip_addr[16];

    int sock_des, n, total = 0;
    FILE *fdlog;

    if (argc < 2) {
	fprintf(stderr, "\nLSTAT client version 1.0 (c)\n");
	fprintf(stderr, "Usage: %s <hostname>\n\n", argv[0]);
	return 0;
    }

/*
    if (inet_aton(argv[1], &address))
	he = gethostbyaddr((char *) &address, sizeof(address), AF_INET);
    else
	he = gethostbyname(argv[1]);


    if (!he) {
	herror("Unknown host");
	fprintf(stderr, "Exiting...\n");
	exit(-1);
    }
*/
    if (!(he = gethostbyname(argv[1]))) {
        herror("Unknown host");
        fprintf(stderr, "Exiting...\n");
        exit(-1);
    }


    addrptr = (struct in_addr **) he->h_addr_list;

    sprintf(ip_addr, "%s", inet_ntoa(**addrptr));

    fprintf(stdout, "LSTAT client version 1.0 (c)\n");
    password = getpass("Password: ");

    printf("\nTrying %s...\n", ip_addr);

    sin.sin_family = he->h_addrtype;
    sin.sin_port = htons(atoi(PORT));
    bcopy(he->h_addr, (char *) &sin.sin_addr, he->h_length);
    bzero(&(sin.sin_zero), 8);

    if ((sock_des = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
	perror("socket()");
	return -1;
    }

    if (connect(sock_des, (struct sockaddr *) &sin, sizeof(sin)) < 0) {
	fprintf(stderr, "Connection failed to %s:%s : %s\n", ip_addr, PORT,
		strerror(errno));
	return -1;
    }

    if (( fdlog = fopen(argv[1], "a+")) == NULL) {
	perror("fopen()");
	return (EXIT_FAILURE);
    }	

    fprintf(stderr, "Connected.\nLogs in file %s\n\n", argv[1]);

    send(sock_des, password, strlen(password) , 0);	

    bzero(BUF, MAXLENGTH); 	


    do {
	n = read(sock_des, BUF, MAXLENGTH);
	
	BUF[n] = '\0';
	if( strstr(BUF, "-OK") == NULL) 
		fputs(BUF, fdlog);
	else 
		fputs(BUF, stdout);

	bzero(BUF, MAXLENGTH);	
	total+=n;	
    } while ( n != 0 );

    fprintf(stdout, "Bytes received : %i\n", total);	

    close(sock_des); fclose(fdlog);
    return 0;
}

