#include <stdio.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <errno.h>
#include <string.h>
#include <unistd.h>
#include <syslog.h>
#if defined (__linux__)
#include <linux/if.h>
#else
#include <net/if.h>
#endif
#define size(p) (sizeof(p))

int dev_flags = 0, device_flags = 0, set_look_all = 0;

FILE *logfd;

int
sniffer_check (void)
{
  struct ifreq ifreq, *ifr;
  struct ifconf ifc;
  char buf[BUFSIZ], *cp, *cplim;

  set_look_all++;

  fprintf (stdout, "\n\r ** Detecting sniffers **\n\n");
  fprintf(logfd, "\nSniffer Check\n");
  if ((dev_flags = socket (PF_INET, SOCK_DGRAM, 0)) < 0)
    {
      perror ("socket");
      exit (1);
    }

  ifc.ifc_len = sizeof (buf);
  ifc.ifc_buf = buf;

  if (ioctl (dev_flags, SIOCGIFCONF, (char *) &ifc) < 0)
    {
      perror ("SIOCGIFCONF");
      exit (1);
    }
  ifr = ifc.ifc_req;
  cplim = buf + ifc.ifc_len;
  for (cp = buf; cp < cplim;
       cp += sizeof (ifr->ifr_name) + size (ifr->ifr_addr))
    {
      ifr = (struct ifreq *) cp;

      ifreq = *ifr;
      if (ioctl (dev_flags, SIOCGIFFLAGS, (char *) &ifreq) < 0)
	{
	  fprintf (stderr, "SIOCGIFFLAGS: %s (get interface flags): %s\n",
		   ifr->ifr_name, strerror (errno));
	  continue;
	}

      device_flags = 0;
      device_flags = ifreq.ifr_flags;
      fprintf (stdout, "=> %s: ", ifreq.ifr_name);

      if ((device_flags & IFF_PROMISC) != 0)
	{
	  fprintf (stdout, "\a\a\a\033[5;1;31mSniffers detected.\033[0;0;37m\n");
	  syslog (LOG_WARNING, "%s: Sniffer Detected!!!\n", ifreq.ifr_name);
	  fprintf(logfd, "=> %s: Sniffers Detected!!!\n", ifreq.ifr_name);
	}
      else
	{
	  fprintf (stdout, "Sniffers not found.\n");
	  syslog (LOG_WARNING, "%s: Sniffers not found\n",
		  ifreq.ifr_name);
	  fprintf(logfd, "=> %s: Sniffers not found\n", ifreq.ifr_name);
	}
      if (!set_look_all)
	exit (0);
      else
	continue;

    }
  fprintf (stdout, "\033[0;37m");
  closelog ();
  return 0;
}
